<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>OSMXBean.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.util</a> &gt; <span class="el_source">OSMXBean.java</span></div><h1>OSMXBean.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.util;

import java.lang.management.ManagementFactory;
import java.lang.management.OperatingSystemMXBean;
import java.lang.management.RuntimeMXBean;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.lang.reflect.Method;

/**
 * This class is a wrapper for the implementation of
 * com.sun.management.UnixOperatingSystemMXBean
 * It will decide to use the sun api or its own implementation
 * depending on the runtime (vendor) used.
 */
public class OSMXBean
{
<span class="fc" id="L42">    static final Logger LOG = LoggerFactory.getLogger(OSMXBean.class);</span>

    private OperatingSystemMXBean osMbean;

<span class="fc" id="L46">    private static final boolean ibmvendor =</span>
<span class="fc" id="L47">        System.getProperty(&quot;java.vendor&quot;).contains(&quot;IBM&quot;);</span>
<span class="fc" id="L48">    private static final boolean windows = </span>
<span class="fc" id="L49">        System.getProperty(&quot;os.name&quot;).startsWith(&quot;Windows&quot;);</span>
<span class="fc" id="L50">    private static final boolean linux =</span>
<span class="fc" id="L51">        System.getProperty(&quot;os.name&quot;).startsWith(&quot;Linux&quot;);</span>

    /**
     * Constructor. Get the running Operating System instance
     */
<span class="fc" id="L56">    public OSMXBean () {</span>
<span class="fc" id="L57">        this.osMbean = ManagementFactory.getOperatingSystemMXBean();</span>
<span class="fc" id="L58">    }</span>
 
    /**
     * Check if the OS is unix. If using the IBM java runtime, this
     * will only work for linux.
     * 
     * @return whether this is unix or not.
     */
    public boolean getUnix() {
<span class="pc bpc" id="L67" title="1 of 2 branches missed.">        if (windows) {</span>
<span class="nc" id="L68">            return false;</span>
        }
<span class="pc bpc" id="L70" title="1 of 2 branches missed.">        return (ibmvendor ? linux : true);</span>
    }

    /**
     * Load the implementation of UnixOperatingSystemMXBean for sun jvm
     * and runs the desired method. 
     * @param mBeanMethodName : method to run from the interface UnixOperatingSystemMXBean
     * @return the method result
     */
    private Long getOSUnixMXBeanMethod (String mBeanMethodName)
    {
        Object unixos;
        Class&lt;?&gt; classRef;
        Method mBeanMethod;

        try {
<span class="fc" id="L86">            classRef = Class.forName(&quot;com.sun.management.UnixOperatingSystemMXBean&quot;);</span>
<span class="pc bpc" id="L87" title="1 of 2 branches missed.">            if (classRef.isInstance(osMbean)) {</span>
<span class="fc" id="L88">                mBeanMethod = classRef.getDeclaredMethod(mBeanMethodName,</span>
                new Class[0]);
<span class="fc" id="L90">                unixos = classRef.cast(osMbean);</span>
<span class="fc" id="L91">                return (Long)mBeanMethod.invoke(unixos);</span>
            }
<span class="nc" id="L93">        } catch(Exception e) {</span>
<span class="nc" id="L94">            LOG.warn(&quot;Not able to load class or method for com.sun.managment.UnixOperatingSystemMXBean.&quot;, e);</span>
<span class="nc" id="L95">        }</span>
<span class="nc" id="L96">        return null;</span>
    }

    /**
     * Get the number of opened filed descriptor for the runtime jvm.
     * If sun java, it will use the com.sun.management interfaces.
     * Otherwise, this methods implements it (linux only).  
     * @return number of open file descriptors for the jvm
     */
    public long getOpenFileDescriptorCount() 
    {
        Long ofdc;
    
<span class="pc bpc" id="L109" title="1 of 2 branches missed.">        if (!ibmvendor) {</span>
<span class="fc" id="L110">            ofdc = getOSUnixMXBeanMethod(&quot;getOpenFileDescriptorCount&quot;);</span>
<span class="pc bpc" id="L111" title="1 of 2 branches missed.">            return (ofdc != null ? ofdc.longValue () : -1);</span>
        }
        
        try {
            //need to get the PID number of the process first
<span class="nc" id="L116">            RuntimeMXBean rtmbean = ManagementFactory.getRuntimeMXBean();</span>
<span class="nc" id="L117">            String rtname = rtmbean.getName();</span>
<span class="nc" id="L118">            String[] pidhost = rtname.split(&quot;@&quot;);</span>

            //using linux bash commands to retrieve info
<span class="nc" id="L121">            Process p = Runtime.getRuntime().exec(</span>
                    new String[] { &quot;bash&quot;, &quot;-c&quot;,
                    &quot;ls /proc/&quot; + pidhost[0] + &quot;/fdinfo | wc -l&quot; });
<span class="nc" id="L124">            InputStream in = p.getInputStream();</span>
<span class="nc" id="L125">            BufferedReader output = new BufferedReader(</span>
                    new InputStreamReader(in));

            try {
                String openFileDesCount;
<span class="nc bnc" id="L130" title="All 2 branches missed.">                if ((openFileDesCount = output.readLine()) != null) {</span>
<span class="nc" id="L131">                    return Long.parseLong(openFileDesCount);</span>
                }
<span class="nc" id="L133">            } finally {</span>
<span class="nc" id="L134">                if (output != null) {</span>
<span class="nc bnc" id="L135" title="All 4 branches missed.">                    output.close();</span>
                }
<span class="nc" id="L137">            }</span>
<span class="nc" id="L138">        } catch (IOException ie) {</span>
<span class="nc" id="L139">            LOG.warn(&quot;Not able to get the number of open file descriptors&quot;, ie);</span>
<span class="nc" id="L140">        }</span>
<span class="nc bnc" id="L141" title="All 2 branches missed.">        return -1;</span>
    }

    /**
     * Get the number of the maximum file descriptors the system can use.
     * If sun java, it will use the com.sun.management interfaces.
     * Otherwise, this methods implements it (linux only).  
     * @return max number of file descriptors the operating system can use.
     */
    public long getMaxFileDescriptorCount()
    {
        Long mfdc;

<span class="pc bpc" id="L154" title="1 of 2 branches missed.">        if (!ibmvendor) {</span>
<span class="fc" id="L155">            mfdc = getOSUnixMXBeanMethod(&quot;getMaxFileDescriptorCount&quot;);</span>
<span class="pc bpc" id="L156" title="1 of 2 branches missed.">            return (mfdc != null ? mfdc.longValue () : -1);</span>
        }
        
        try {
            //using linux bash commands to retrieve info
<span class="nc" id="L161">            Process p = Runtime.getRuntime().exec(</span>
                    new String[] { &quot;bash&quot;, &quot;-c&quot;, &quot;ulimit -n&quot; });
<span class="nc" id="L163">            InputStream in = p.getInputStream();</span>
<span class="nc" id="L164">            BufferedReader output = new BufferedReader(</span>
                    new InputStreamReader(in));

            try {
                String maxFileDesCount;
<span class="nc bnc" id="L169" title="All 2 branches missed.">                if ((maxFileDesCount = output.readLine()) != null) {</span>
<span class="nc" id="L170">                    return Long.parseLong(maxFileDesCount);</span>
                }
<span class="nc" id="L172">            } finally {</span>
<span class="nc" id="L173">                if (output != null) {</span>
<span class="nc bnc" id="L174" title="All 4 branches missed.">                    output.close();</span>
                }
<span class="nc" id="L176">            }</span>
<span class="nc" id="L177">        } catch (IOException ie) {</span>
<span class="nc" id="L178">            LOG.warn(&quot;Not able to get the max number of file descriptors&quot;, ie);</span>
<span class="nc" id="L179">        }</span>
<span class="nc bnc" id="L180" title="All 2 branches missed.">        return -1;</span>
    }  
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>